﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace TreeViewExpandAll
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        #region public attributes
        public ObservableCollection<DataItem> Items { get; set; }
        #endregion

        #region constructor
        public MainWindow()
        {
            InitializeComponent();
            this.radTreeView.DataContext = this; //works
            LoadData();
        }
        #endregion

        private void LoadData()
        {
            Items = GenerateItems();
            NotifyPropertyChanged("Items");
            MessageBox.Show("Before First invoke of expandAll()!");
            this.radTreeView.ExpandAll();
            MessageBox.Show("After First invoke of expandAll() !");
        }

        #region private members
        private ObservableCollection<DataItem> GenerateItems()
        {
            ObservableCollection<DataItem> result = new ObservableCollection<DataItem>();
            for (int i = 0; i < 8; i++)
            {
                DataItem item = new DataItem() { Header = String.Format("Item {0}", i) };
                for (int j = 0; j < 5; j++)
                {
                    DataItem child = new DataItem() { Header = String.Format("Item {0}.{1}", i, j) };

                    for (int k = 0; k < 3; k++)
                    {
                        child.Children.Add(new DataItem() { Header = String.Format("Item {0}.{1}.{2}", i, j, k) });
                    }
                    item.Children.Add(child);
                }
                result.Add(item);
            }
            return result;
        }

        #endregion


        #region Events
        /// <summary>
        /// Occurs when a property value changes.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;
        /// <summary>
        /// Notifies the property changed.
        /// </summary>
        /// <param name="info">The info.</param>
        private void NotifyPropertyChanged(string info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion

        private void radTreeView_Loaded(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Treeview Loaded");
            //You should uncomment the following line in order to view the expanded treview
            // this.radTreeView.ExpandAll();
        }
    }
}
